#include "common_al.h"

/* initialized to all NULL */
gadl_list_t *list1, *list2;

static const char *elem2str(item_t *i)
{
	static char buff[8][128];
	static int nextbuff = 0;
	char *b;

	if (i == NULL)
		return "<NULL>";

	b = buff[(nextbuff++)%8];

	sprintf(b, "%s: %s", ptr2id(i), i->payload);
	return b;
}

static void dump_list(gadl_list_t *list, const char *banner)
{
	gadl_iterator_t it;
	item_t *i;

	printf("\n%s {length=%d}\n", banner, gadl_length(list));

	gadl_foreach(list, &it, i) {
		printf(" [%d] %s\n", gadl_it_idx(&it), elem2str(i));
	}
	gdl_check(&(list->dlist));
}

int cmp_elem_str(item_t *i, char *str)
{
	if (i == NULL)
		return !(str == NULL);
	return strcmp(i->payload, str);
}

static item_t *new_item(gadl_list_t *list, const char *payload)
{
	return init_item(gadl_new(list), payload);
}

static void init_fill(gadl_list_t *list, int count)
{
	int n;

	for(n = 0; n < count; n++) {
		char tmp[128];
		item_t *i;

		sprintf(tmp, "init_fill %d", n);
		i = new_item(list, tmp);
		gadl_append(list, i);
	}
}
