#include "common_l.h"

/* initialized to all NULL */
gdl_list_t list1, list2;

static const char *elem2str(item_t *i)
{
	static char buff[8][128];
	static int nextbuff = 0;
	char *b;

	if (i == NULL)
		return "<NULL>";

	b = buff[(nextbuff++)%8];

	sprintf(b, "%s (%s, %s): %s", ptr2id(i), ptr2id(i->l1.prev), ptr2id(i->l1.next), i->payload);
	return b;
}

static void dump_list(gdl_list_t *list, const char *banner)
{
	gdl_iterator_t it;
	item_t *i;

	printf("\n%s {length=%d}\n", banner, list->length);

	gdl_foreach(list, &it, i) {
		printf(" [%d] %s\n", gdl_it_idx(&it), elem2str(i));
	}
	gdl_check(list);
}

#define  dump_list1(banner) dump_list(&list1, banner)
#define  dump_list2(banner) dump_list(&list2, banner)

int cmp_elem_str(item_t *i, char *str)
{
	if (i == NULL)
		return !(str == NULL);
	return strcmp(i->payload, str);
}


static void init_fill(gdl_list_t *list, int count)
{
	int n;

	for(n = 0; n < count; n++) {
		char tmp[128];
		item_t *i;

		sprintf(tmp, "init_fill %d", n);
		i = new_item(tmp);
		gdl_append(list, i, l1);
	}
}
